static char rcsid[] = "@(#)$Id: init.c,v 1.2 2008-05-13 17:39:43 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.2 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/


#include "def_alias.h"
#include "s_me.h"


#if ANSI_C
#define S_(x) static x;
#else
#define S_(x)
#endif

struct aliases_map * system_aliases_map = NULL;
struct aliases_map * user_aliases_map = NULL;


S_(dump_conf_map_f dump_user_aliases_file)
static void dump_user_aliases_file P_((FILE *f));
static void dump_user_aliases_file(f) 
     FILE *f;
{
    dump_aliases_map(f,user_aliases_map);
}

S_(dump_message_f user_aliases_file_written)
static void user_aliases_file_written P_((char *fname));
static void user_aliases_file_written(fname)
     char *fname;
{

    lib_error(CATGETS(elm_msg_cat, MeSet, 
		      MeAliasesInfoSavedIn,
		      "Aliases info saved in file %s."), 
	      fname);

}




#if ANSI_C
static init_default_hook init_alias_defaults;
#endif
static void init_alias_defaults P_((int *errors));
static void init_alias_defaults(errors)
     int *errors;
{
    system_aliases_map = load_aliases_map(system_aliases_file,errors);
    
    register_conf_write(USER_ALIASES_FILE,user_aliases_file,
			dump_user_aliases_file,
			user_aliases_file_written);

}

#if ANSI_C
static init_default_hook alias_read_rc_file;
#endif
static void alias_read_rc_file P_((int *errors));
static void alias_read_rc_file(errors)
     int *errors;
{
    user_aliases_map = load_aliases_map(user_aliases_file,errors);
}

void init_aliaslib()
{
    add_init_default_hook(&init_alias_defaults);
    add_read_rc_file_hook(&alias_read_rc_file);

}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
