static char rcsid[] = "@(#)$Id: conf_writer.c,v 2.2 2008-05-13 17:39:43 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 2.2 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/


#include "def_misc.h"
#include "s_me.h"
#include "conf_writer_imp.h"

DEBUG_VAR(Debug,__FILE__,"config");


void write_conf()
{
    int i;

    for (i = 0; i < cfiles_num; i++) {
	int err;
	FILE *f = NULL;
	char *tmp;

	tmp = elm_message(FRM("%s.N"),cfiles[i].fname);
	err = can_open(tmp,"w");
	if (err)
	    lib_error(CATGETS(elm_msg_cat, MeSet, MeFileNotWriteable,
			      "File %.50s is not writeable: %s"),
		      tmp, strerror(err));
	else if (!(f = fopen(tmp,"w"))) {
	    int err = errno;
	    lib_error(CATGETS(elm_msg_cat, MeSet, MeFileNotWriteable,
			      "File %.50s is not writeable: %s"),
		      tmp, strerror(err));
	} else {
	    cfiles[i].dump_map(f);

	    if (EOF == fclose(f)) {
		int err = errno;
		lib_error(CATGETS(elm_msg_cat, MeSet, MeFileNotWriteable,
				  "File %.50s is not writeable: %s"),
			  tmp, strerror(err));
		
	    } else if (0 != rename(tmp,cfiles[i].fname)) {
		int err = errno;
		lib_error(CATGETS(elm_msg_cat, MeSet, MeFileNotRenamed,
				  "Failed to rename temporary file to %.50s: %30s"),
			  cfiles[i].fname, 
			  strerror(err));
		
	    } else {
		cfiles[i].write_message(cfiles[i].fname);
	    }
	}
	free(tmp);

    }
}

struct string * conf_taglist(sep)
     struct string *sep;

{
    struct string * ret = format_string(FRM("(none)"));

    int i;

    for (i = 0; i < cfiles_num; i++) {
	struct string * X;
					
	
	if (i == cfiles_num-1)
	    X = format_string(FRM("%S %S %s"),
			      ret,sep,cfiles[i].shortname);
	else if (i > 0) 
	    X = format_string(FRM("%S, %s"),
			      ret,cfiles[i].shortname);
	else
	    X = format_string(FRM("%s"),
			      cfiles[i].shortname);
	    
	free_string(&ret);
	ret = X;
    }

    return ret;
}


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
