case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	ln ../../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac

case "$subdir" in
'')
    case "$0" in
    */*) cd `expr X$0 : 'X\(.*\)/'` ;;
    esac	    

    vpathdef="#VPATH		= "
    XXsrc="."
    XXsrcroot="../../"
    ;;
*)
    vpathdef="VPATH		=	$source_dir/$subdir"
    XXsrc="$source_dir/$subdir"
    XXsrcroot="$source_dir"
    ;;
esac

echo "Extracting src/url/Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 2.2 2008-05-25 15:52:52 hurtta Exp $
#  Makefile for the ELM mail program.
#
# Variables
#	Variables established by Configure
AR		=	$ar
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CHMOD		=	$chmod
CP		=	$cp
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
RM		= 	$rm -f
TOUCH		=	$touch
TAGS		=	ctags
$vpathdef
SRC		=	$XXsrc
SRCROOT		=	$XXsrcroot
!GROK!THIS!

cat >>Makefile <<'!NO!SUBS!'
#	Other general variables
CFLAGS		=	-I$(IHDR) -I$(INCLDIR) $(CCFLAGS) $(OPTIMIZE) $(DEBUG) 
INCLDIR		=	$(SRCROOT)/hdrs
IHDR		=	../../hdrs
SHELL		=	/bin/sh

OBJ		=	url.o url_element.o url_path.o no_url.o \
 mailto.o http.o imap.o



all:			Makefile liburl.a

install_s:		Makefile liburl.a

uninstall_s:		

clean:
	$(RM) $(OBJ) liburl.a

Makefile: Makefile.SH ../../config.sh
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

liburl.a:		$(OBJ)
			$(AR) r $@ $?
			$(RANLIB) $@

#	Dependencies of header files upon other header files they include
.PRECIOUS:		$(IHDR)/elm_defs.h $(IHDR)/defs_major.h def_url.h \
 $(IHDR)/me.h $(IHDR)/misclib.h

$(IHDR)/elm_defs.h:	$(IHDR)/defs_major.h $(INCLDIR)/elm_nl_types.h \
 $(INCLDIR)/elmlib.h 
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(IHDR)/defs_major.h:   ../../config.h $(IHDR)/sysdefs.h 
			$(CHMOD) u+w $@
			$(TOUCH) $@


def_url.h:		$(IHDR)/elm_defs.h $(IHDR)/me.h \
 $(INCLDIR)/mailerlib.h $(INCLDIR)/mboxlib.h 
			cmp $(SRC)/$@ $@ || $(CP) $(SRC)/$@ $@
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(IHDR)/misclib.h: $(INCLDIR)/mlist_common.h
			$(CHMOD) u+w $@
			$(TOUCH) $@


$(IHDR)/me.h:	$(INCLDIR)/melib.h $(IHDR)/misclib.h $(INCLDIR)/addrlib.h \
 $(INCLDIR)/aliaslib.h  $(INCLDIR)/mime.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

#	Dependencies of C object files

url.o:	     def_url.h $(INCLDIR)/s_me.h
url_element.o:	     def_url.h $(INCLDIR)/s_me.h
url_path.o:	     def_url.h $(INCLDIR)/s_me.h
no_url.o:	     def_url.h 
http.o:		     def_url.h 
mailto.o:	     def_url.h $(INCLDIR)/s_me.h
imap.o:		     def_url.h $(INCLDIR)/s_me.h
!NO!SUBS!
